> ## Documentation Index
> Fetch the complete documentation index at: https://www.commercengine.io/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List all saved payment methods

> This endpoint acts as a proxy for JusPay's Fetch Saved Payment Methods API. It enables to securely retrieve a list of payment methods (such as saved cards, UPI handles, wallets) that have been previously stored for a given customer.

The operation helps streamline the checkout flow by allowing users to quickly select from existing payment methods, reducing input friction and improving conversion.

You can filter the results by payment method type using the payment_method query parameter. Multiple payment methods can be specified by separating them with commas (e.g., payment_method=upi_collect,card,wallet).

API documentation of JusPay can be found at below link:

https://juspay.io/in/docs/api-reference/docs/express-checkout/fetch-saved-payment-methods



## OpenAPI

````yaml get /customers/{customer_id}/payment-methods
openapi: 3.1.0
info:
  version: '1.0'
  title: CE Storefront APIs
  summary: Customer-facing e-commerce API for building exceptional shopping experiences
  description: >-
    Public-facing API for Commerce Engine storefronts, enabling seamless
    shopping experiences with product browsing, cart management, checkout
    processing, user accounts, and order tracking. Perfect for building web,
    mobile, and headless commerce applications.
  contact:
    name: Support
    email: support@commercengine.io
    url: https://www.commercengine.io/contact-us
  license:
    url: https://www.commercengine.io/contact-us
    name: All Rights Reserved
servers:
  - url: https://staging.api.commercengine.io/api/v1/{store_id}/storefront
    description: Staging Server
    variables:
      store_id:
        description: Store ID
        default: store_id
    x-speakeasy-server-id: staging
  - url: https://prod.api.commercengine.io/api/v1/{store_id}/storefront
    description: Prod Server
    variables:
      store_id:
        description: Store ID
        default: store_id
    x-speakeasy-server-id: prod
security: []
tags:
  - name: Analytics
    description: Analytics
  - name: Auth
    description: auth
  - name: Campaigns
    description: Campaigns
  - name: Carts
    description: Carts
  - name: Catalog
    description: Catalog
  - name: Common
    description: Common
  - name: Coupons & promotions
    description: Coupons & promotions
  - name: Customers
    description: Customers
  - name: Juspay
    description: Juspay Payments
  - name: KYC
    description: KYC
  - name: Marketplace
    description: Marketplace
  - name: Orders
    description: Orders
  - name: Others
    description: Others
  - name: Payments
    description: Payments
  - name: PayU
    description: PayU Payments
  - name: POS
    description: POS
  - name: Shipping
    description: Shipping
  - name: Store
    description: Store
  - name: Subscriptions
    description: Subscriptions
externalDocs:
  url: https://llm-docs.commercengine.io
  description: Commerce Engine API Reference Documentation
paths:
  /customers/{customer_id}/payment-methods:
    parameters:
      - name: customer_id
        in: path
        description: Customer Id
        required: true
        schema:
          type: string
    get:
      tags:
        - Customers
      summary: List all saved payment methods
      description: >-
        This endpoint acts as a proxy for JusPay's Fetch Saved Payment Methods
        API. It enables to securely retrieve a list of payment methods (such as
        saved cards, UPI handles, wallets) that have been previously stored for
        a given customer.


        The operation helps streamline the checkout flow by allowing users to
        quickly select from existing payment methods, reducing input friction
        and improving conversion.


        You can filter the results by payment method type using the
        payment_method query parameter. Multiple payment methods can be
        specified by separating them with commas (e.g.,
        payment_method=upi_collect,card,wallet).


        API documentation of JusPay can be found at below link:


        https://juspay.io/in/docs/api-reference/docs/express-checkout/fetch-saved-payment-methods
      operationId: list-saved-payment-methods
      parameters:
        - name: payment_methods
          in: query
          description: >-
            Filter payment methods by type. Accepts multiple payment method
            types separated by commas. Example:
            payment_method=upi_collect,card,wallet. Available payment method
            types include: upi_collect, card, wallet.
          required: false
          schema:
            type: string
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
                properties:
                  message:
                    type: string
                  success:
                    type: boolean
                  content:
                    properties:
                      saved_payment_methods:
                        $ref: '#/components/schemas/SavedPaymentMethod'
                    type: object
          links:
            CreateOrder:
              operationId: create-order
              description: >-
                Create an order using a saved payment method. Use the saved
                payment method details to construct a `JusPayExpressCheckout`
                payment method payload.
        '401':
          $ref: '#/components/responses/Unauthorized'
        '404':
          $ref: '#/components/responses/NotFound'
      security:
        - Authorization: []
      externalDocs:
        url: >-
          https://llm-docs.commercengine.io/storefront/operations/list-saved-payment-methods
        description: API reference for the list-saved-payment-methods operation
components:
  schemas:
    SavedPaymentMethod:
      title: SavedPaymentMethod
      type: object
      externalDocs:
        url: >-
          https://llm-docs.commercengine.io/storefront/schemas/SavedPaymentMethod
        description: API reference for the SavedPaymentMethod schema
      properties:
        upi_collect:
          type: array
          items:
            type: object
            required:
              - count
              - last_used
              - vpa
            properties:
              count:
                type: integer
              last_used:
                type: string
              vpa:
                type: string
        wallet:
          type: array
          items:
            type: object
            required:
              - id
              - wallet
              - gateway_reference_id
              - last_refreshed
            properties:
              linked:
                type: string
              id:
                type: string
              metadata:
                type: object
                properties:
                  mobile_number:
                    type: string
                  device_id:
                    type: string
                required:
                  - mobile_number
                  - 'device_id '
              wallet:
                type: string
              gateway_reference_id:
                type: string
              last_refreshed:
                type: string
              sub_details:
                type: object
                properties:
                  last_used:
                    type: string
                  current_balance:
                    type: string
                  last_refreshed:
                    type: string
                  payment_method:
                    type: string
                  payment_method_type:
                    type: string
                required:
                  - last_used
                  - current_balance
                  - last_refreshed
                  - payment_method
                  - payment_method_type
        card:
          type: array
          items:
            type: object
            required:
              - card_sub_type
              - extended_card_type
              - provider_category
              - vault_provider
              - card_type
              - card_token
              - card_exp_month
              - expired
              - tokenize_support
              - card_exp_year
              - name_on_card
              - country_code
              - card_number
            properties:
              card_sub_type:
                type: string
              extended_card_type:
                type: string
              card_global_fingerprint:
                type: string
              nickname:
                type: string
              provider_category:
                type: string
              vault_provider:
                type: string
              card_reference:
                type: string
              card_type:
                type: string
              metadata:
                type: object
                properties:
                  origin_merchant_id:
                    type: string
                required:
                  - origin_merchant_id
              card_issuer:
                type: string
              card_token:
                type: string
              card_exp_month:
                type: string
              provider:
                type: string
              card_sub_type_category:
                type: string
              expired:
                type: boolean
              card_fingerprint:
                type: string
              tokenize_support:
                type: boolean
              juspay_bank_code:
                type: string
              card_exp_year:
                type: string
              name_on_card:
                type: string
              country_code:
                type: string
              card_number:
                type: string
              card_isin:
                type: string
              card_brand:
                type: string
              card_issuer_country:
                type: string
  responses:
    Unauthorized:
      description: Not authorized for given operation on the Resource
      content:
        application/json:
          schema:
            type: object
            required:
              - message
              - success
              - code
            properties:
              message:
                type: string
                examples:
                  - Not authorized for given operation on the Resource.
                x-speakeasy-error-message: true
              success:
                type: boolean
                default: false
              code:
                type: string
                examples:
                  - unauthorized
    NotFound:
      description: Requested resource not found
      content:
        application/json:
          schema:
            type: object
            required:
              - message
              - success
              - code
            properties:
              message:
                type: string
                x-speakeasy-error-message: true
              success:
                type: boolean
              code:
                type: string
  securitySchemes:
    Authorization:
      type: http
      description: Access token
      scheme: bearer

````